/* strings.c */
/* operations sur les chaines */
/* version 0.63 */
/* Rgis Cridlig 1991-19934*/

#include "../Include/z2k2.h"

#include <stdlib.h> /* pour getenv */

/* create_string is handled by primitive: make_string */

obj_t compare_strings(obj_t s1,obj_t s2)  /* ML */
{ ulint len1, len2;
  register ulint len;
  register unsigned char *p1, *p2;

  len1 = CINT(STRING_LENGTH(s1));
  len2 = CINT(STRING_LENGTH(s2));
  for (len = (len1 <= len2 ? len1 : len2), 
         p1 = (unsigned char *)STRING(s1), 
         p2 = (unsigned char *)STRING(s2);
       len > 0;
       len--, p1++, p2++)
    if (*p1 != *p2)
      return (*p1 < *p2) ? MLINT(-1) : MLINT(1); 
  if (len1 == len2)
    return MLINT(0);
  else if (len1 < len2)
    return MLINT(-2);
  else
    return MLINT(2);
}

obj_t  /* ML */
blit_string(obj_t s1, obj_t offset1, obj_t s2, obj_t offset2, obj_t len)
{
  bcopy(&BYTE(s1, CINT(offset1)), &BYTE(s2, CINT(offset2)), CINT(len));
  return MLVOID;
}

obj_t fill_string(obj_t s, obj_t offset, obj_t len, obj_t init) /* ML */
{ register unsigned char *p;
  register ulint n;
  register unsigned char c;

  c = CINT(init);
  for(p = &BYTE(s, CINT(offset)), n = CINT(len); n > 0; n--, p++) *p = c;
  return MLVOID;
}

#ifdef unix
static unsigned char printable_chars_ascii[32] = /* 0x20-0x7E */
  "\000\000\000\000\377\377\377\377\377\377\377\377\377\377\377\177\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000";
static unsigned char printable_chars_iso[32] = /* 0x20-0x7E 0xA1-0xFF */
  "\000\000\000\000\377\377\377\377\377\377\377\377\377\377\377\177\000\000\000\000\376\377\377\377\377\377\377\377\377\377\377\377";
#endif
#ifdef macintosh
static unsigned char printable_chars[32] = /* 0x20-0x7E 0x80-0xC9 0xCB-0xD8 */
  "\000\000\000\000\377\377\377\377\377\377\377\377\377\377\377\177\377\377\377\377\377\377\377\377\377\373\377\001\000\000\000\000";
#endif
#ifdef MSDOS
static unsigned char printable_chars[32] = /* 0x20-0xFE */
  "\000\000\000\000\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\177";
#endif

obj_t is_printable(obj_t chr) /* ML */
{
  int c;
#ifdef unix
  static int iso_charset = -1;
  unsigned char * printable_chars;

  if (iso_charset == -1) {
    char * lc_ctype = (char *) getenv("LC_CTYPE");
    if (lc_ctype != 0 && strcmp(lc_ctype, "iso_8859_1") == 0)
      iso_charset = 1;
    else
      iso_charset = 0;
  }
  printable_chars = iso_charset ? printable_chars_iso : printable_chars_ascii;
#endif

  c = CINT(chr);
  return (printable_chars[c >> 3] & (1 << (c & 7))) ? KTRUE : KFALSE;
}
